<?php
require_once('common.php');

$_SESSION['values'] = array();

ob_start();

$consumer = getConsumer();

$return_to = getReturnTo();
$response = $consumer->complete($return_to);

if ($response->status == Auth_OpenID_CANCEL) {
	$msg = 'Verification cancelled.';
} elseif ($response->status == Auth_OpenID_FAILURE) {
	$msg = "OpenID authentication failed: " . $response->message;
} elseif ($response->status == Auth_OpenID_SUCCESS) {
	$openid_identity = (isset($response->endpoint->claimed_id) ? $response->endpoint->claimed_id : $response->getDisplayIdentifier());

	$success = sprintf('You have successfully verified ' .
                           '<a href="%s">%s</a> as your identity.',
                           $esc_identity, $esc_identity);

	$ax_resp = Auth_OpenID_AX_FetchResponse::fromSuccessResponse($response);

	if ($ax_resp) {
		foreach ($ax_attributes as $key => $value) {
			$_SESSION['values'][$key] = (isset($ax_resp->data[$value['scheme']]) ? $ax_resp->data[$value['scheme']] : '');
		}
	}
}

ob_end_clean();

include 'index.php';